<?php
/*******************************************************************
 *			
 * 			Fichier			:	functions.php 
 * 			Cr le			:	27 mars 2002 
 * 			Dernire modif	:	08 dcembre 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2004 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('FUNCTIONS_INC') )
{

define('FUNCTIONS_INC', true);

/*
 * page_header()
 * 
 * Affichage du haut de page
 * 
 * @return void
 */
function page_header($use_template = true, $page_title = '')
{
	global $waroot, $nl_config, $lang, $template, $admindata, $auth;
	global $meta, $simple_header, $error, $msg_error;
	
	define('HEADER_INC', true);
	
	if( $use_template )
	{
		$template->set_filenames(array(
			'header' => ( $simple_header ) ? 'simple_header.tpl' :'header.tpl'
		));
		
		if( defined('IN_ADMIN') )
		{
			mozilla_nav('top index', './index.php'             , $lang['Title']['accueil']);
			mozilla_nav('chapter', './config.php'              , $lang['Module']['config']);
			mozilla_nav('chapter', './envoi.php'               , $lang['Title']['send']);
			mozilla_nav('chapter', './view.php?mode=abonnes'   , $lang['Module']['subscribers']);
			mozilla_nav('chapter', './view.php?mode=liste'     , $lang['Module']['list']);
			mozilla_nav('chapter', './view.php?mode=log'       , $lang['Module']['log']);
			mozilla_nav('chapter', './tools.php?mode=export'   , $lang['Title']['export']);
			mozilla_nav('chapter', './tools.php?mode=import'   , $lang['Title']['import']);
			mozilla_nav('chapter', './tools.php?mode=ban'      , $lang['Title']['ban']);
			mozilla_nav('chapter', './tools.php?mode=generator', $lang['Title']['generator']);
			
			if( $admindata['admin_level'] == ADMIN )
			{
				mozilla_nav('chapter', './tools.php?mode=attach' , $lang['Title']['attach']);
				mozilla_nav('chapter', './tools.php?mode=backup' , $lang['Title']['backup']);
				mozilla_nav('chapter', './tools.php?mode=restore', $lang['Title']['restore']);
			}
			
			mozilla_nav('chapter'   , './admin.php'                                             , $lang['Module']['users']);
			mozilla_nav('chapter'   , './stats.php'                                             , $lang['Title']['stats']);
			mozilla_nav('help'      , $waroot . 'docs/faq_' . $lang['CONTENT_LANG'] . '.html'   , $lang['Faq']);
			mozilla_nav('author'    , $waroot . 'docs/readme_' . $lang['CONTENT_LANG'] . '.html', $lang['Author_note']);
			mozilla_nav('copyright' , 'http://www.gnu.org/copyleft/gpl.html', 'Copyleft');
			
			$page_title = sprintf($lang['General_title'], htmlspecialchars($nl_config['sitename']));
		}
		else
		{
			mozilla_nav('top index', './profil_cp.php'                 , $lang['Title']['accueil']);
			mozilla_nav('section'  , './profil_cp.php?mode=editprofile', $lang['Module']['editprofile']);
			mozilla_nav('section'  , './profil_cp.php?mode=archives'   , $lang['Module']['log']);
			mozilla_nav('section'  , './profil_cp.php?mode=logout'     , $lang['Module']['logout']);
			
			$page_title = $lang['Title']['profil_cp'];
		}
		
		$template->assign_vars( array(
			'PAGE_TITLE'   => $page_title,
			'META'         => $meta,
			'CONTENT_LANG' => $lang['CONTENT_LANG'],
			'CONTENT_DIR'  => $lang['CONTENT_DIR'],
			'CONTENT_TYPE' => ( MODE_XHTML ) ? 'application/xhtml+xml' : 'text/html',
			'CHARSET'      => $lang['CHARSET'],
			'L_LOG'        => $lang['Module']['log'],
			
			'L_LOGOUT'     => $lang['Module']['logout'],
			'S_NAV_LINKS'  => mozilla_nav()
		));
		
		if( defined('IN_ADMIN') )
		{
			$template->assign_vars(array(
				'L_INDEX'       => $lang['Module']['accueil'],
				'L_CONFIG'      => $lang['Module']['config'],
				'L_SEND'        => $lang['Module']['send'],
				'L_SUBSCRIBERS' => $lang['Module']['subscribers'],
				'L_LIST'        => $lang['Module']['list'],
				'L_TOOLS'       => $lang['Module']['tools'],
				'L_USERS'       => $lang['Module']['users'],
				'L_STATS'       => $lang['Module']['stats'],
				
				'SITENAME'      => htmlspecialchars($nl_config['sitename']),
			));
			
			if( $admindata['session_liste'] && isset($auth->listdata[$admindata['session_liste']]) )
			{
				$template->assign_block_vars('display_liste', array(
					'LISTE_NAME' => $auth->listdata[$admindata['session_liste']]['liste_name']
				));
			}
		}
		else
		{
			$template->assign_vars(array(
				'L_EDITPROFILE' => $lang['Module']['editprofile']
			));
		}
		
		if( $error )
		{
			error_box($msg_error);
		}
		
		wa_headers($lang['CHARSET']);
		
		$template->pparse('header');
	}
	else
	{
		$lg      = ( !empty($lang['CONTENT_LANG']) ) ? $lang['CONTENT_LANG'] : 'fr';
		$dir     = ( !empty($lang['CONTENT_DIR']) ) ? $lang['CONTENT_DIR'] : 'ltr';
		$charset = ( !empty($lang['CHARSET']) ) ? $lang['CHARSET'] : 'iso-8859-1';
		
		wa_headers($charset);
		
		echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
		echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"{$lg}\" lang=\"{$lg}\" dir=\"{$dir}\">\n";
		echo "<head>\n" . $meta;
		echo "<title>$page_title</title>\n";
		echo "<style type=\"text/css\" media=\"screen\">\n";
		echo 'body { margin: 10px; text-align: left; }' . "\n";
		echo "</style>\n</head>\n<body>\n\n<div>\n";
	}
}

/*
 * page_footer()
 * 
 * Affichage du pied de page.
 * Termine l'excution du script.
 * 
 * @return void
 */
function page_footer($use_template = true)
{
	global $nl_config, $db, $template, $lang, $starttime;
	
	if( $use_template )
	{
		$endtime   = array_sum(explode(' ', microtime()));
		$totaltime = ($endtime - $starttime);
		
		$template->set_filenames(array(
			'footer' => 'footer.tpl'
		));
		
		$template->assign_vars( array(
			'VERSION'   => $nl_config['version'], 
			'TRANSLATE' => ( !empty($lang['TRANSLATE']) ) ? ' | Translate by ' . $lang['TRANSLATE'] : ''
		));
		
		if( DEV_INFOS == TRUE )
		{
			$template->assign_block_vars('dev_infos', array(
				'TIME_TOTAL' => sprintf('%.8f', $totaltime),
				'TIME_PHP'   => sprintf('%.3f', $totaltime - $db->sql_time),
				'TIME_SQL'   => sprintf('%.3f', $db->sql_time),
				'QUERIES'    => $db->queries
			));
		}
		
		$template->pparse('footer');
	}
	else
	{
		echo "\n</div>\n\n</body>\n</html>\n";
	}
	
	//
	// On ferme la connexion  la base de donnes, si elle existe 
	//
	if( isset($db) && is_object($db) )
	{
		$db->close_connexion();
	}
	
	exit;
}

/*
 * wa_headers()
 * 
 * Envoi des enttes de non-mise en cache et du prologue xml si celui ci est support par
 * le navigateur client
 * 
 * @return void
 */
function wa_headers($charset)
{
	header('Cache-Control: no-cache, must-revalidate, private, pre-check=0, post-check=0, max-age=0');
	header('Expires: ' . gmdate('D, d M Y H:i:s', time()) . ' GMT');
	header('Last-Modified: ' . gmdate('D, d M Y H:i:s', time()) . ' GMT');
	header('Pragma: no-cache');
	
	if( MODE_XHTML )
	{
		header('Content-Type: application/xhtml+xml; charset=' . $charset);
		
		//
		// Sparation des dbuts de balise et fin de balise de ? sinon, le parseur de php plante...
		//
		echo '<' . '?xml version="1.0" encoding="' . $charset . '"?' . '>' . "\n";
	}
	else
	{
		header('Content-Type: text/html; charset=' . $charset);
	}
}

/*
 * generate_key()
 * 
 * Gnration d'une chane alatoire
 * 
 * @param integer $num_char	: nombre de caractres
 * 
 * @return string
 */
function generate_key($num_char = 32)
{
	$rand_str = md5( uniqid( rand() ) );
	
	return ( $num_char >= 32 ) ? $rand_str : substr($rand_str, 0, $num_char);
}

/*
 * make_script_url()
 * 
 * Construction de l'url du script
 * 
 * @param string $url	: Url relative
 * 
 * @return string
 */
function make_script_url($url = '')
{
	global $nl_config;
	
	$excluded_ports = array(80, 8080);
	
	$server_name = preg_replace('/^http(s)?:\/\/(.*?)\/?$/', 'http\\1://\\2', $nl_config['urlsite']);
	$server_port = ( !in_array(getenv('SERVER_PORT'), $excluded_ports) ) ? ':' . getenv('SERVER_PORT') : '';
	$script_path = ( $nl_config['path'] != '/' ) ? preg_replace('/^\/?(.*?)\/?$/', '/\\1/', $nl_config['path']) : '/';
	
	return $server_name . $server_port . $script_path . $url;
}

/*
 * Location()
 * 
 * Fonction de redirection du script avec url absolue, d'aprs les 
 * spcifications HTTP/1.1
 * 
 * @param string $url	: Url relative de redirection
 * 
 * @return void
 */
function Location($url)
{
	global $nl_config, $db;
	
	//
	// On ferme la connexion  la base de donnes, si elle existe 
	//
	if( isset($db) && is_object($db) )
	{
		$db->close_connexion();
	}
	
	$use_refresh = preg_match("#Microsoft|WebSTAR|Xitami#i", getenv('SERVER_SOFTWARE'));
	$header_location = ( $use_refresh ) ? 'Refresh: 0; URL=' : 'Location: ';
	
	$absolute_url  = make_script_url() . ( ( defined('IN_ADMIN') ) ? 'admin/' : '' );
	$absolute_url .= str_replace('&amp;', '&', $url);
	
	header($header_location . $absolute_url);
	
	//
	// Si la fonction header() ne donne rien, on affiche une page de redirection 
	//
	$message = 'If your browser doesn\'t support meta redirect, click <a href="' . $url . '">here</a> to go on next page.';
	
	$meta = meta_refresh($url, 0);
	page_header(false, 'Redirection');
	
	echo $message;
	
	page_footer(false);
}

/*
 * meta_refresh()
 * 
 * Fonction qui construit le meta "Refresh", ceci afin d'viter 
 * d'avoir du html se baladant dans le code php
 * 
 * @param string $url	: Url de redirection
 * @param string $timer	: Temps avant redirection
 * 
 * @return string
 */
function meta_refresh($url, $timer)
{
	return '<meta http-equiv="Refresh" content="' . $timer . '; url=' . $url . '" />';
}

/*
 * mozilla_nav()
 * 
 * Construction de la barre de navigation Mozilla/Netscape
 * 
 * @param string $rel	: Type de 'relation' du lien
 * @param string $url	: Url de la page
 * @param string $title	: Libell du lien
 * 
 * @return mixed
 */
function mozilla_nav($rel = '', $url = '', $title = '')
{
	static $s_nav_links;
	
	if( $rel != '' && $url != '' && $title != '' )
	{
//		if( !ereg('\.html$', $url) )
//		{
			if( !isset($s_nav_links) )
			{
				$s_nav_links = '';
			}
			
			$url = ( function_exists('sessid') ) ? sessid($url) : $url;
			$s_nav_links .= '<link rel="' . $rel . '" href="' . $url . '" title="' . $title . '" />' . "\n\t";
//		}
		
		return true;
	}
	else
	{
		$tmp = $s_nav_links;
		$s_nav_links = '';
		
		return trim($tmp);
	}
}

/*
 * hidden_fields()
 * 
 * Cration des champs cachs
 * 
 * @param $name	 : Nom du champs
 * @param $value : valeur du champs
 * 
 * @return mixed
 */
function hidden_fields($name = '', $value = '')
{
	static $s_hidden_fields;
	
	if( !empty($name) )
	{
		if( !isset($s_hidden_fields) )
		{
			$s_hidden_fields = '';
		}
		
		$s_hidden_fields .= '<input type="hidden" name="' . $name . '" value="' . $value . '" />' . "\n";
		
		return true;
	}
	else
	{
		$tmp = $s_hidden_fields;
		$s_hidden_fields = '';
		
		return trim($tmp);
	}
}

/*
 * get_data()
 * 
 * Rcupration du nombre de logs, inscrits, inscrits en attente 
 * de confirmation pour la/les liste(s) donne(s)
 * 
 * @param mixed $liste_id_mixed	: Id, ou tableau contenant les id de la/les listes 
 * 
 * @return array
 */
function get_data($liste_id_mixed)
{
	global $db;
	
	if( is_array($liste_id_mixed) )
	{
		$sql_where = 'IN(' . implode(', ', $liste_id_mixed) . ')';
	}
	else
	{
		$sql_where = '= ' . $liste_id_mixed;
	}
	
	$data = array('num_inscrits' => 0, 'num_temp' => 0, 'num_logs' => 0, 'last_log' => 0);
	
	$sql = "SELECT COUNT(DISTINCT(a.abo_id)) AS num_abo, a.abo_status 
		FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
		WHERE al.liste_id $sql_where AND a.abo_id = al.abo_id 
		GROUP BY a.abo_status";
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir le nombre d\'inscrits/inscrits en attente', ERROR);
	}
	
	while( $row = $db->fetch_array($result) )
	{
		if( $row['abo_status'] == ABO_ACTIF )
		{
			$data['num_inscrits'] = $row['num_abo'];
		}
		else
		{
			$data['num_temp'] = $row['num_abo'];
		}
	}
	
	$sql = "SELECT SUM(liste_numlogs) AS num_logs 
		FROM " . LISTE_TABLE . " 
		WHERE liste_id " . $sql_where;
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir le nombre de logs envoys', ERROR);
	}
	
	if( $row = $db->fetch_array($result) )
	{
		$data['num_logs'] = $row['num_logs'];
	}
	
	$sql = "SELECT MAX(log_date) AS last_log 
		FROM " . LOG_TABLE . " 
		WHERE log_status = " . STATUS_SENDED . " AND liste_id " . $sql_where;
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir la date du dernier envoy', ERROR);
	}
	
	if( $row = $db->fetch_array($result) )
	{
		$data['last_log'] = $row['last_log'];
	}
	
	return $data;
}

/*
 * load_settings()
 * 
 * Initialisation des prfrences et du moteur de templates
 * 
 * @param array $admindata	: Donnes utilisateur
 * 
 * @return void
 */
function load_settings($admindata = array())
{
	global $waroot, $nl_config, $db, $lang, $datetime, $template;
	
	$template_path = $waroot . 'templates/';
	if( defined('IN_ADMIN') )
	{
		$template_path .= 'admin/';
	}
	$template = new Template($template_path);
	
	if( !is_array($admindata) )
	{
		$admindata = array();
	}
	
	if( !empty($admindata['admin_lang']) )
	{
		$nl_config['language'] = $admindata['admin_lang'];
	}
	
	if( !empty($admindata['admin_dateformat']) )
	{
		$nl_config['date_format'] = $admindata['admin_dateformat'];
	}
	
	$language_path = wa_realpath($waroot . 'language/lang_' . $nl_config['language'] . '.php');
	
	if( !file_exists($language_path) )
	{
		$nl_config['language'] = 'francais';
		$language_path = wa_realpath($waroot . 'language/lang_' . $nl_config['language'] . '.php');
		
		if( !file_exists($language_path) )
		{
			trigger_error('<b>Les fichiers de language sont introuvables !</b>', CRITICAL_ERROR);
		}
	}
	
	include($language_path);
}

/*
 * wanewsletter_handler()
 * 
 * Gestionnaire d'erreur personnalis du script 
 * 
 * @param integer $errno	: Code de l'erreur
 * @param string  $errstr	: Texte proprement dit de l'erreur
 * @param string  $errfile	: Fichier o s'est produit l'erreur
 * @param integer $errline  : Numro de la ligne 
 * 
 * @return void
 */
function wanewsletter_handler($errno, $errstr, $errfile, $errline)
{
	global $waroot, $db, $template, $lang, $message, $php_errormsg;
	
	$debug_text = '';
	
	if( defined('IN_CRON') && $errno == ERROR )
	{
		$errno = CRITICAL_ERROR;
	}
	
	if( ( $errno == CRITICAL_ERROR || $errno == ERROR ) && ( defined('IN_ADMIN') || defined('IN_CRON') || DEBUG_MODE ) )
	{
		if( !empty($db->sql_error['message']) )
		{
			$debug_text .= '<b>SQL query</b> :<br /> ' . nl2br($db->sql_error['query']) . "<br /><br />\n";
			$debug_text .= '<b>SQL errno</b> : ' . $db->sql_error['errno'] . "<br />\n";
			$debug_text .= '<b>SQL error</b> : ' . $db->sql_error['message'] . "<br />\n<br />\n";
		}
		
		$debug_text .= '<b>Fichier</b> : ' . basename($errfile) . " \n<b>Ligne</b> : " . $errline . ' <br />';
	}
	
	if( !empty($lang['Message'][$errstr]) )
	{
		$errstr = nl2br($lang['Message'][$errstr]);
	}
	
	if( $debug_text != '' )
	{
		$errstr .= "<br /><br />\n\n" . $debug_text;
	}
	
	switch( $errno )
	{
		case CRITICAL_ERROR:
			page_header(false, 'Erreur critique !');
			
			echo "<h1>Erreur critique !</h1>\n\n<p>" . $errstr . '</p>';
			
			page_footer(false);
			break;
		
		case ERROR:			
		case MESSAGE:
			if( defined('IN_CRON') )
			{
				exit($errstr);
			}
			
			if( !defined('IN_WA_FORM') && !defined('IN_SUBSCRIBE') )
			{
				if( $errno == ERROR )
				{
					$msg_title = '<span style="color: #DD3333;">' . $lang['Title']['error'] . '</span>';
				}
				else if( $errno == MESSAGE )
				{
					$msg_title = '<span style="color: #33DD33;">' . $lang['Title']['info'] . '</span>';
				}
				
				if( !defined('HEADER_INC') )
				{
					page_header();
				}
				
				$template->set_filenames(array(
					'body' => 'message_body.tpl'
				));
				
				$template->assign_vars( array(
					'MSG_TITLE' => $msg_title,
					'MSG_TEXT'  => $errstr
				));
				
				$template->pparse('body');
				
				page_footer();
			}
			
			$message = $errstr;
			break;
	}
	
	$php_errormsg = '';
	
	if( $errno == E_WARNING )
	{
		$php_errormsg .= '<b>Warning !</b> : ';
	}
	else if( $errno == E_NOTICE )
	{
		$php_errormsg .= '<b>Notice</b> : ';
	}
	
	$php_errormsg .= $errstr . ' in <b>' . basename($errfile) . '</b> on line <b>' . $errline . '</b>';
	
	
	//
	// Dans le cas d'une fonction prcde par @, error_reporting() 
	// retournera 0, dans ce cas, pas d'affichage d'erreur
	//
	$display_error = error_reporting(E_ALL);
	
	if( $errno != ERROR && ( DEBUG_MODE == 3 || ( $display_error && DEBUG_MODE > 1 ) ) )
	{
		if( $errno != E_WARNING && $errno != E_NOTICE )
		{
			exit;
		}
		
		echo '<p>' . $php_errormsg . '</p>';
	}
}

/*
 * plain_error()
 * 
 * @param $str
 * 
 * @return void
 */
function plain_error($str)
{
	header('Content-Type: text/plain; charset=iso-8859-1');
	
	echo $str;
	exit;
}

/*
 * navigation()
 * 
 * Fonction d'affichage par page.
 * 
 * @param string  $url				: adresse vers laquelle doivent pointer les liens de navigation
 * @param integer $total_item		: nombre total d'lments
 * @param integer $item_per_page	: nombre d'lments par page
 * @param integer $page_id			: identifiant de la page en cours
 * 
 * @return string
 */
function navigation($url, $total_item, $item_per_page, $page_id)
{
	global $lang;
	
	$total_pages = ceil($total_item / $item_per_page);
	
	// premier caractre de l'url au moins en position 1 
	// on place un espace  la position 0 de la chane
	$url = ' ' . $url;
	
	$url .= ( strpos($url, '?') ) ? '&amp;' : '?';
	
	// suppression de l'espace prcdemment ajout 
	$url = substr($url, 1);
	
	if( $total_pages == 1 )
	{
		return '&nbsp;';
	}
	
	$nav_string = '';
	
	if( $total_pages > 10 )
	{
		if( $page_id > 10 )
		{
			$prev = $page_id;
			do
			{
				$prev--;
			}
			while( $prev % 10 );
			
			$nav_string .= '<a href="' . $url . 'page=1">' . $lang['Start'] . '</a>&nbsp;&nbsp;';
			$nav_string .= '<a href="' . $url . 'page=' . $prev . '">' . $lang['Prev'] . '</a>&nbsp;&nbsp;';
		}
		
		$current = $page_id;
		do
		{
			$current--;
		}
		while( $current % 10 );
		
		$current++;
		
		for( $i = $current; $i < ($current + 10); $i++ )
		{
			if( $i <= $total_pages )
			{
				if( $i > $current )
				{
					$nav_string .= ', ';
				}
				
				$nav_string .= ( $i == $page_id ) ? '<b>' . $i . '</b>' : '<a href="' . $url . 'page=' . $i . '">' . $i . '</a>';
			}
		}
		
		$next = $page_id;
		while( $next % 10 )
		{
			$next++;
		}
		$next++;
		
		if( $total_pages >= $next )
		{
			$nav_string .= '&nbsp;&nbsp;<a href="' . $url . 'page=' . $next . '">' . $lang['Next'] . '</a>';
			$nav_string .= '&nbsp;&nbsp;<a href="' . $url . 'page=' . $total_pages . '">' . $lang['End'] . '</a>';
		}
	}
	else
	{
		for( $i = 1; $i <= $total_pages; $i++ )
		{
			if( $i > 1 )
			{
				$nav_string .= ', ';
			}
			
			$nav_string .= ( $i == $page_id ) ? '<b>' . $i . '</b>' : '<a href="' . $url . 'page=' . $i . '">' . $i . '</a>';
			
		}
	}
	
	return $nav_string;
}

/*
 * convert_time()
 * 
 * Fonction de renvoi de date selon la langue
 * 
 * @param string  $dateformat	: Format demand
 * @param integer $timestamp	: timestamp unix  convertir
 * 
 * @return string
 */
function convert_time($dateformat, $timestamp)
{
	static $search, $replace;
	
	if( !isset($orig_ary) || !isset($repl_ary) )
	{
		global $datetime;
		
		$search = $replace = array();
		
		foreach( $datetime AS $orig_word => $repl_word )
		{
			$search[]  = '/\b' . $orig_word . '\b/i';
			$replace[] = $repl_word;
		}
	}
	
	return preg_replace($search, $replace, date($dateformat, $timestamp));
}

/*
 * build_listbox()
 * 
 * Selon le mode, affiche une page de slection d'une liste, insert la 
 * liste droulante de changement de liste dans le coin en bas  droite de la page, 
 * ou retourne le code html de la liste droulante de slection
 * 
 * @param string  $mode			: Mode de fonctionnement  utiliser
 * @param integer $auth_type	: Code de permission
 * @param string  $jump_to		: Url de destination de l'ventuel formulaire (si mode display ou corner)
 * 
 * Si mode diffrent de display et de corner, la fonction retourne le code html de 
 * la liste droulante, dans ce cas, la fonction rcupre des paramtres supplmentaires avec func_get_args()
 * 
 * @param integer $not_this_id	: Id de liste  ignorer
 * @param boolean $confirm_only	: Si on ne veut que les listes qui demandent confirmation
 * 
 * @return string
 */
function build_listbox($mode, $auth_type, $jump_to = '')
{
	global $admindata, $auth, $session, $template, $lang;
	
	$list_box = false;
	$tmp_box  = '';
	$args_ary = func_get_args();
	
	if( $mode == 'display' || $mode == 'corner' )
	{
		$jump_to = $args_ary[2];
		$select_name = 'liste';
	}
	else
	{
		$select_name  = ( !empty($args_ary[2]) ) ? $args_ary[2] : 'liste';
		$not_this_id  = ( !empty($args_ary[3]) ) ? $args_ary[3] : 0;
		$confirm_only = ( !empty($args_ary[4]) ) ? $args_ary[4] : 0;
	}
	
	$liste_id_ary = $auth->check_auth($auth_type);
	
	foreach( $auth->listdata AS $liste_id => $data )
	{
		if( in_array($liste_id, $liste_id_ary) && ( $mode == 'display' || $mode == 'corner' || ( $liste_id != $not_this_id && ( !$confirm_only || $data['confirm_subscribe'] ) ) ) )
		{
			$selected = ( $admindata['session_liste'] == $liste_id ) ? ' selected="selected"' : '';
			
			$liste_name = $data['liste_name'];
			if( strlen($liste_name) > 30 )
			{
				$liste_name = substr($liste_name, 0, 30);
				$liste_name = substr($liste_name, 0, strrpos($liste_name, ' ')) . '...';
			}
			
			$tmp_box .= '<option value="' . $liste_id . '"' . $selected . '> - ' . $liste_name . ' - </option>';
		}			
	}
	
	if( $tmp_box != '' )
	{
		$list_box  = '<select id="' . $select_name . '" name="' . $select_name . '">';
		if( $mode == 'corner' )
		{
			$list_box .= '<option value="0"> - ' . $lang['Choice_liste'] . ' - </option>';
			$list_box .= '<option value="0"> -------------------- </option>';
		}
		
		$list_box .= $tmp_box . '</select>';
		
		hidden_fields('sessid', $session->session_id);
		
		if( $mode == 'corner' )
		{
			$template->set_filenames(array(
				'list_box_body' => 'list_box.tpl'
			));
			
			$template->assign_vars(array(
				'L_VIEW_LIST'     => $lang['View_liste'],
				'L_BUTTON_GO'     => $lang['Button']['go'],
				
				'S_LISTBOX'       => $list_box,
				'S_HIDDEN_FIELDS' => hidden_fields(),
				
				'U_LISTBOX'       => sessid($jump_to)
			));
			
			$template->assign_var_from_handle('LISTBOX', 'list_box_body');
		}
		else if( $mode == 'display' )
		{
			page_header();
			
			$template->set_filenames(array(
				'body' => 'select_liste_body.tpl'
			));
			
			$template->assign_vars(array(
				'L_TITLE'         => $lang['Title']['select'],
				'L_SELECT_LISTE'  => $lang['Choice_liste'],
				'L_VALID_BUTTON'  => $lang['Button']['valid'],
				
				'LISTE_BOX'       => $list_box,
				'S_HIDDEN_FIELDS' => hidden_fields(),
				'U_FORM'          => sessid($jump_to)
			));
			
			$template->pparse('body');
			
			page_footer();
		}
	}
	else if( $mode == 'display' )
	{
		$message = $lang['Message']['No_liste_exists'];
		
		if( $admindata['admin_level'] == ADMIN )
		{
			$message .= '<br /><br />' . sprintf($lang['Click_create_liste'], '<a href="' . sessid('view.php?mode=liste&amp;action=add') . '">', '</a>');
		}
		
		trigger_error($message, MESSAGE);
	}
	
	return $list_box;
}

/*
 * files_list()
 * 
 * Affichage des fichiers joints 
 * 
 * @param string  $page			: Page concerne (pour les liens) (envoi.php ou view.php)
 * @param array   $logdata		: Donnes du log concern
 * @param integer $num_files	: Nombre de fichiers
 * @param integer $format		: Format du log visualis (si dans view.php)
 * 
 * @return boolean
 */
function files_list($page, $logdata, $num_files, $format = 0)
{
	global $waroot, $template, $lang, $session;
	
	$total_log_size  = 1024; // ~ 1024 correspond au poids de base d'un email (enttes)
	
	$body_size = (strlen($logdata['log_body_text']) + strlen($logdata['log_body_html']));
	
	$total_log_size += ( $body_size > 0 ) ? ($body_size / 2) : 0;
	
	$test_ary = array();
	for( $i = 0; $i < $num_files; $i++ )
	{
		$total_log_size += $logdata['joined_files'][$i]['file_size'];
		
		$test_ary[] = $logdata['joined_files'][$i]['file_real_name'];
	}
	
	if( $format == FORMAT_HTML )
	{
		preg_match_all('/<.+?"cid:([^\\:*\/?<">|]+)"[^>]*>/i', $logdata['log_body_html'], $matches);
		
		$embed_ary = array_intersect($test_ary, $matches[1]);
		
		if( ($num_files - count($embed_ary)) == 0 )
		{
			return false;
		}
	}
	
	if( $total_log_size >= 1048576 )
	{
		$lang_size 		 = $lang['MO'];
		$total_log_size /= 1048576;
	}
	else if( $total_log_size > 1024 )
	{
		$lang_size 		 = $lang['KO'];
		$total_log_size /= 1024;
	}
	else
	{
		$lang_size = $lang['Octets'];
	}
	
	$l_total_log_size = sprintf('%.2f', $total_log_size) . ' ' . $lang_size;
	
	$template->set_filenames(array(
		'files_box_body' => 'files_box.tpl'
	));
	
	$template->assign_vars(array(
		'L_FILENAME'        => $lang['Filename'],
		'L_FILESIZE'        => $lang['Filesize'],
		'L_TOTAL_LOG_SIZE'  => $lang['Total_log_size'],
		
		'TOTAL_LOG_SIZE'    => $l_total_log_size,
		'S_ROWSPAN'         => ( $page == 'envoi.php' ) ? '4' : '3'
	));
	
	if( $page == 'envoi.php' )
	{
		$template->assign_block_vars('del_column', array());
	}
	
	$u_download = $page . '?mode=download&amp;fid=';
	
	for( $i = 0; $i < $num_files; $i++ )
	{
		$filesize = $logdata['joined_files'][$i]['file_size'];
		$filename = $logdata['joined_files'][$i]['file_real_name'];
		$file_id  = $logdata['joined_files'][$i]['file_id'];
		$mimetype = $logdata['joined_files'][$i]['file_mimetype'];
		
		//
		// On affiche pas dans la liste les fichiers incorpors dans 
		// une newsletter au format HTML.
		//
		if( $format == FORMAT_HTML && in_array($filename, $embed_ary) )
		{
			continue;
		}
		
		if( $filesize >= 1048576 )
		{
			$lang_size = $lang['MO'];
			$filesize /= 1048576;
		}
		else if( $filesize > 1024 )
		{
			$lang_size = $lang['KO'];
			$filesize /= 1024;
		}
		else
		{
			$lang_size = $lang['Octets'];
		}
		
		$l_filesize = sprintf('%.2f', $filesize) . ' ' . $lang_size;
		
		if( ereg('^image/', $mimetype) )
		{
			$s_show  = '<a href="' . $waroot . 'options/show.php?mode=view&amp;file=' . $filename . '&amp;sessid=' . $session->session_id . '" onclick="show(' . $file_id . '); return false;">';
			$s_show .= '<img src="' . $waroot . 'images/icon_loupe.gif" width="14" height="14" alt="Voir" title="' . $lang['Show'] . '" />';
			$s_show .= '</a>';
		}
		else
		{
			$s_show = '';
		}
		
		$template->assign_block_vars('file_info', array(
			'OFFSET'	 => ($i + 1),
			'FILENAME'	 => htmlspecialchars($filename),
			'FILESIZE'	 => $l_filesize,
			'S_SHOW'	 => $s_show,
			'U_DOWNLOAD' => sessid($u_download . $file_id)
		));
		
		if( $page == 'envoi.php' )
		{
			$template->assign_block_vars('file_info.delete_options', array(
				'FILE_ID' => $file_id
			));
		}
	}
	
	$template->assign_var_from_handle('JOINED_FILES_BOX', 'files_box_body');
	
	return true;
}

/*
 * error_box()
 * 
 * Affichage des erreurs survenues aprs soumission d'un formulaire
 * 
 * @param mixed $msg_error_mixed	: L'erreur, ou les erreurs survenues
 * 
 * @return void
 */
function error_box($msg_error_mixed)
{
	global $template;
	
	$error_box = "<ul id=\"errorbox\">\n\t<li> ";
	if( is_array($msg_error_mixed) )
	{
		$error_box .= implode(" </li>\n\t<li> ", $msg_error_mixed);
	}
	else
	{
		$error_box .= $msg_error_mixed;
	}
	$error_box .= " </li>\n</ul>";
	
	$template->assign_vars( array(
		'ERROR_BOX' => $error_box
	));
}

/*
 * purge_liste()
 * 
 * Fonction de purge de la table des abonns 
 * Retourne le nombre d'entres supprimes
 * Fonction rcursive
 * 
 * @param integer $liste_id			: Liste concerne
 * @param integer $limitevalidate	: Limite de validit pour confirmer une inscription
 * @param integer $purge_freq		: Frquence des purges
 * 
 * @return integer
 */
function purge_liste($liste_id = 0, $limitevalidate = 0, $purge_freq = 0)
{
	global $db, $nl_config;
	
	if( !$liste_id )
	{
		$total_entries_deleted = 0;
		
		$sql = "SELECT liste_id, limitevalidate, purge_freq 
			FROM " . LISTE_TABLE . " 
			WHERE purge_next < " . time() . " 
				AND auto_purge = " . TRUE;
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir les listes de diffusion  purger', ERROR);
		}
		
		while( $row = $db->fetch_array($result) )
		{
			$total_entries_deleted += purge_liste($row['liste_id'], $row['limitevalidate'], $row['purge_freq']);
		}
		
		//
		// Optimisation des tables
		//
		$db->check(array(ABONNES_TABLE, ABO_LISTE_TABLE));
		
		return $total_entries_deleted;
	}
	else
	{
		$sql = "SELECT a.abo_id 
			FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
			WHERE al.liste_id = $liste_id 
				AND a.abo_id = al.abo_id 
				AND a.abo_status = " . ABO_INACTIF . " 
				AND a.abo_register_date < " . (time() - ($limitevalidate * 86400));
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir les entres  supprimer', ERROR);
		}
		
		$abo_id_ary = array();
		while( $row = $db->fetch_array($result) )
		{
			$abo_id_ary[] = $row['abo_id'];
		}
		
		if( $num_abo_deleted = count($abo_id_ary) )
		{
			$db->transaction(START_TRC);
			
			$sql = "DELETE FROM " . ABO_LISTE_TABLE . " 
				WHERE abo_id IN(" . implode(', ', $abo_id_ary) . ")";
			if( !$db->query($sql) )
			{
				trigger_error('Impossible de supprimer les entres primes de la table abo_liste', ERROR);
			}
			
			$sql = "DELETE FROM " . ABONNES_TABLE . " 
				WHERE abo_id IN(" . implode(', ', $abo_id_ary) . ")";
			if( !$db->query($sql) )
			{
				trigger_error('Impossible de supprimer les entres primes de la table abonnes', ERROR);
			}
			
			$sql = "UPDATE " . LISTE_TABLE . " 
				SET purge_next = " . (time() + ($purge_freq * 86400)) . " 
				WHERE liste_id = " . $liste_id;
			if( !$db->query($sql) )
			{
				trigger_error('Impossible de mettre  jour la table liste', ERROR);
			}
			
			$db->transaction(END_TRC);
		}
		
		return $num_abo_deleted;
	}
}

/*
 * emul_magic_quotes_gpc()
 * 
 * Simulation de la configuration magic_quotes_gpc  on
 * Fonction rcursive
 * 
 * @param array $data	: Tableau des donnes
 * 
 * @return void
 */
function emul_magic_quotes_gpc(&$data)
{
	if( is_array($data) )
	{
		foreach( $data AS $key => $val )
		{
			if( is_array($val) )
			{
				emul_magic_quotes_gpc($val);
			}
			else if( is_string($val) )
			{
				$data[$key] = addslashes($val);
			}
		}
	}
}

/*
 * wa_realpath()
 * 
 * Fonction similaire  realpath() mais utilise un autre moyen d'obtenir l'url canonique si 
 * la fonction realpath() est dsactive
 * 
 * @param string $relative_path	: Url relative  rsoudre
 * 
 * @return string
 */
function wa_realpath($relative_path)
{
	global $waroot;
	
	if( !@function_exists('realpath') || !@realpath($waroot . 'includes/functions.php') )
	{
		if( !empty($_SERVER['SCRIPT_FILENAME']) )
		{
			$script_path = str_replace('\\', '/', dirname($_SERVER['SCRIPT_FILENAME']));
			
			//
			// FIX multimania
			//
			if( stristr($script_path, 'free') && stristr($script_path, 'multimania') )
			{
				return $relative_path;
			}
			
			$ary = explode('/', $relative_path);
			$dir = array();
			
			for( $i = 0; $i < count($ary); $i++ )
			{
				if( $ary[$i] != '..' && $ary[$i] != '.' )
				{
					$dir[] = $ary[$i];
				}
				else if( $ary[$i] == '..' )
				{
					$script_path = substr($script_path, 0, strrpos($script_path, '/'));
				}
			}
			
			return $script_path . '/' . implode('/', $dir);
		}
		
		return $relative_path;
	}
	
	return str_replace('\\', '/', realpath($relative_path));
}

/*
 * unhtmlspecialchars()
 * 
 * Fonction inverse de la fonction htmlspecialchars()
 * 
 * @param string $input
 * 
 * @return string
 */
function unhtmlspecialchars($input)
{
	$html_entities = array('/&lt;/', '/&gt;/', '/&quot;/', '/&amp;/');
	$html_replace  = array('<', '>', '"', '&');
	
	return preg_replace($html_entities, $html_replace, $input);
}

/*
 * cut_str()
 * 
 * Pour limiter la longueur d'une chaine de caractre  afficher
 * 
 * @param string  $str
 * @param integer $len
 * 
 * @return string
 */
function cut_str($str, $len)
{
	if( strlen($str) > $len )
	{ 
		$str = substr($str, 0, ($len - 3));
		
		if( $space = strrpos($str, ' ') )
		{
			$str = substr($str, 0, $space);
		}
		
		$str .= '...';
	}
	
	return $str;
}

/*
 * active_urls()
 * 
 * Convertit les liens dans un texte en lien html
 * Import de WAgoldBook 2.0.x et prcdemment import de phpBB 2.0.x
 * 
 * @param string $str
 * 
 * @return string
 */
function active_urls($str)
{
	$str = ' ' . $str;
	
	$str = preg_replace("#([\n ])([a-z]+?)://([^,\t \n\r\"]+)#i", "\\1<a href=\"\\2://\\3\">\\2://\\3</a>", $str);
	$str = preg_replace("#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^,\t \n\r\"]*)?)#i", "\\1<a href=\"http://www.\\2.\\3\\4\">www.\\2.\\3\\4</a>", $str);
	$str = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)?[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $str);
	
	// Remove our padding..
	return substr($str, 1);
}

/*
 * is_available_extension()
 * 
 * Vrifie si une extension est charge, et tente de le faire si ce n'est pas le cas
 * 
 * @param string $module	: Nom de l'extension
 * 
 * @return boolean
 */
function is_available_extension($module)
{
/*	$module_file = ( stristr(PHP_OS, 'WIN') ) ? 'php_' . $module . '.dll' : $module . '.so';
	
	if( extension_loaded($module) || ( !config_status('safe_mode') && config_status('enable_dl') && @dl($module_file) ) )
	{
		return true;
	}
	
	return false;
	
*/	return extension_loaded($module);
}

/*
 * config_status()
 * 
 * Retourne le statut d'une directive de configuration (telle que rgle sur On ou Off)
 * 
 * @param string $config_name	: Nom de la directive
 * 
 * @return boolean
 */
function config_status($config_name)
{
	return ( ($config_val = @ini_get($config_name)) == 1 || strtolower($config_val) == 'on' ) ? true : false;
}

/*
 * server_info()
 * 
 * Retourne l'information serveur demande
 * 
 * @param string $name 	: Nom de l'information
 * 
 * @return string
 */
function server_info($name)
{
	$name = strtoupper($name);
	
	return ( !empty($_SERVER[$name]) ) ? $_SERVER[$name] : ( ( !empty($_ENV[$name]) ) ? $_ENV[$name] : '' );
}

/*
 * fake_header()
 * 
 * Fonctions  utiliser lors des longues boucles (backup, envois) 
 * qui peuvent provoquer un time out du navigateur client 
 * Inspir d'un code quivalent dans phpMyAdmin 2.5.0 (libraries/build_dump.lib.php prcisment)
 * 
 * @param boolean $in_loop		: True si on est dans la boucle, false pour initialiser $time
 * 
 * @return void
 */
function fake_header($in_loop)
{
	static $time;
	
	if( $in_loop )
	{
		$new_time = time();
		
		if( ($new_time - $time) >= 30 )
		{
			$time = $new_time;
			header('X-WaPing: Pong');
		}
	}
	else
	{
		$time = time();
	}
}

/*
 * make_sql_ary()
 * 
 * Parse un fichier contenant une liste de requte et 
 * renvoie un tableau avec une requte par entre
 * 
 * @param string $input 		: Contenu du fichier .sql
 * @param string $delimiter		: Dlimiteur entre chaque requte (en gnral -> ; )
 * @param string $prefixe		: Prfixe des tables  mettre  la place du prefixe par dfaut
 * 
 * @return array
 */
function make_sql_ary($input, $delimiter, $prefixe = '')
{
	$tmp            = '';
	$output         = array();
	$in_comments    = false;
	$between_quotes	= false;
	
	$lines          = preg_split("/(\r\n?)|\n/", $input, -1, PREG_SPLIT_DELIM_CAPTURE);
	$total_lines    = count($lines);
	
	fake_header(false);
	
	for( $i = 0; $i < $total_lines; $i++ )
	{
		if( preg_match("/^(\r\n?)|\n$/", $lines[$i]) )
		{
			if( $between_quotes )
			{
				$tmp .= $lines[$i];
			}
			
			continue;
		}
		
		//
		// Si on est pas dans des simples quotes, on vrifie si on entre ds des commentaires
		//
		if( !$between_quotes && !$in_comments && preg_match('/^\/\*/', $lines[$i]) )
		{
			$in_comments = true;
		}
		
		if( $between_quotes || ( !$in_comments && strlen($lines[$i]) > 0 && $lines[$i]{0} != '#' ) )
		{
			//
			// Nombre de simple quotes non chapps
			//
			$unescaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*'/", $lines[$i], $matches);
			
			if( ( !$between_quotes && !($unescaped_quotes % 2) ) || ( $between_quotes && ($unescaped_quotes % 2) ) )
			{
				if( preg_match('/' . $delimiter . '$/i', rtrim($lines[$i])) )
				{
					$lines[$i] = ( $tmp != '' ) ? rtrim($lines[$i]) : trim($lines[$i]);
					$output[]  = $tmp . substr($lines[$i], 0, -(strlen($delimiter)));
					$tmp = '';
				}
				else
				{
					$tmp .= ( $tmp != '' ) ? $lines[$i] : ltrim($lines[$i]);
				}
				
				$between_quotes = false;
			}
			else
			{
				$between_quotes = true;
				$tmp .= ( $tmp != '' ) ? $lines[$i] : ltrim($lines[$i]);
			}
		}
		
		if( !$between_quotes && $in_comments && preg_match("/\*\/$/", rtrim($lines[$i])) )
		{
			$in_comments = false;
		}
		
		//
		// Pour tenter de mnager la mmoire 
		//
		unset($lines[$i]);
		
		fake_header(true);
	}
	
	if( $prefixe != '' )
	{
		$output = preg_replace('/wa_/', $prefixe, $output);
	}
	
	//
	// Pour tenter de mnager la mmoire 
	//
	unset($input, $lines);
	
	return $output;
}

//
// Appel du gestionnaire d'erreur 
//
@set_error_handler('wanewsletter_handler');

}
?>